"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _util = _interopRequireDefault(require("./util"));

let _filelistCache = {};
const cachePath = '.wemixcache';
let _buildCache = null;
let _cacheChanged = false;
var _default = {
  setFileList(key, v) {
    _filelistCache[key] = v;
  },

  getFileList(key) {
    return _filelistCache[key] || null;
  },

  getConfig() {
    return this._config || null;
  },

  setConfig(v = null) {
    this._config = v;
  },

  getDist() {
    return 'dist';
  },

  getSrc() {
    return 'src';
  },

  getBuildCache(file) {
    if (_buildCache) {
      return _buildCache;
    }

    if (_util.default.isFile(cachePath)) {
      _buildCache = _util.default.readFile(cachePath);

      try {
        _buildCache = JSON.parse(_buildCache);
      } catch (e) {
        _buildCache = null;
      }
    }

    return _buildCache || {};
  },

  setBuildCache(file) {
    let cache = this.getBuildCache();
    cache[file] = _util.default.getModifiedTime(file);
    _buildCache = cache;
    _cacheChanged = true;
  },

  clearBuildCache() {
    _util.default.unlink(cachePath);
  },

  saveBuildCache() {
    if (_cacheChanged) {
      _util.default.writeFile(cachePath, JSON.stringify(_buildCache || {}));

      _cacheChanged = false;
    }
  },

  checkBuildCache(file) {
    let cache = this.getBuildCache();
    return cache[file] && cache[file] === _util.default.getModifiedTime(file);
  }

};
exports.default = _default;