"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _imagemin = _interopRequireDefault(require("imagemin"));

var _imageminMozjpeg = _interopRequireDefault(require("imagemin-mozjpeg"));

var _imageminPngquant = _interopRequireDefault(require("imagemin-pngquant"));

var _util = _interopRequireDefault(require("./util"));

var _cache = _interopRequireDefault(require("./cache"));

const src = _cache.default.getSrc();

const dist = _cache.default.getDist();

var _default = {
  compile(opath, config) {
    let filepath = _path.default.join(opath.dir, opath.base);

    let target = _util.default.getDistPath(opath, opath.ext, src, dist);

    (0, _imagemin.default)([filepath], '', {
      plugins: [(0, _imageminMozjpeg.default)({}), (0, _imageminPngquant.default)({
        quality: '65-80'
      })]
    }).then(files => {
      _util.default.output('编译', filepath);

      _util.default.output('写入', target);

      _util.default.writeFile(target, files[0].data);

      _cache.default.saveBuildCache();
    }).catch(error => {
      _util.default.error(JSON.stringify(error));
    });
  }

};
exports.default = _default;