"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _util = _interopRequireDefault(require("./util"));

var _cache = _interopRequireDefault(require("./cache"));

var _compileJs = _interopRequireDefault(require("./compile-js"));

const src = _cache.default.getSrc();

const dist = _cache.default.getDist();

var _default = {
  grabConfigFromScript(str, n) {
    let stash = [];
    let rst = '';

    for (let i = n, l = str.length; i < l; i++) {
      if (str[i] === '{') {
        stash.push('{');
      }

      if (str[i] === '}') {
        stash.pop();

        if (stash.length === 0) {
          rst += '}';
          break;
        }
      }

      if (stash.length) {
        rst += str[i];
      }
    }

    return rst;
  },

  compile(opath, status, config) {
    let filepath = _path.default.join(opath.dir, opath.base);

    let content = _util.default.readFile(filepath) || '';
    content.replace(/export\s*default\s*class\s*(\w+)\s*extends/ig, (m, title) => {
      let match = content.match(new RegExp(`[\\s\\r\\n]${title}.config\\s*=[\\s\\r\\n]*`));
      match = match ? match[0] : undefined;
      let json = match ? this.grabConfigFromScript(content, content.indexOf(match) + match.length) : false;

      try {
        if (json) {
          json = new Function(`return ${json}`)();
          /* eslint-disable-line */
        }
      } catch (e) {
        _util.default.output('错误', _path.default.join(opath.dir, opath.base));

        _util.default.error(`解析config出错，报错信息：${e}\r\n${json}`);
      }

      let jsonTarget = _util.default.getDistPath(opath, 'json', src, dist);

      _util.default.output('编译', filepath);

      _util.default.output('写入', jsonTarget);

      _util.default.writeFile(jsonTarget, JSON.stringify(json || {}));
    });

    _compileJs.default.compile(content, opath, status, config);
  }

};
exports.default = _default;