"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _prettyData = require("pretty-data");

var _util = _interopRequireDefault(require("./util"));

var _cache = _interopRequireDefault(require("./cache"));

const src = _cache.default.getSrc();

const dist = _cache.default.getDist();

var _default = {
  compile(opath, config) {
    let filepath = _path.default.join(opath.dir, opath.base);

    let target = _util.default.getDistPath(opath, 'wxml', src, dist);

    let content = _util.default.readFile(filepath) || '';

    if (config.env === 'production') {
      content = _prettyData.pd.xmlmin(content);
    }

    _util.default.output('编译', filepath);

    _util.default.output('写入', target);

    _util.default.writeFile(target, content);

    _cache.default.saveBuildCache();
  }

};
exports.default = _default;