"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _util = _interopRequireDefault(require("./util"));

var _cache = _interopRequireDefault(require("./cache"));

var _compileWxml = _interopRequireDefault(require("./compile-wxml"));

var _compileWxss = _interopRequireDefault(require("./compile-wxss"));

var _compileJson = _interopRequireDefault(require("./compile-json"));

var _compileJs = _interopRequireDefault(require("./compile-js"));

var _compileWemix = _interopRequireDefault(require("./compile-wemix"));

var _compileImage = _interopRequireDefault(require("./compile-image"));

const src = _cache.default.getSrc();

const dist = _cache.default.getDist();

var _default = {
  compile(opath) {
    let config = _util.default.getConfig();

    switch (opath.ext) {
      case '.js':
        let status;

        if (opath.name === 'app') {
          status = 'app';
        } else if (opath.dir.indexOf('/src/pages') > -1) {
          status = 'page';
        } else if (opath.dir.indexOf('/src/components') > -1) {
          status = 'component';
        }

        if (status === 'app' || status === 'page' || status === 'component') {
          _compileWemix.default.compile(opath, status, config);
        } else {
          _compileJs.default.compile(null, opath, 'normal', config);
        }

        break;

      case '.less':
        _compileWxss.default.compile(opath, config);

        break;

      case '.jpg':
      case '.png':
      case '.jpeg':
        _compileImage.default.compile(opath, config);

        break;

      case '.html':
      case '.wxml':
      case '.xml':
        _compileWxml.default.compile(opath, config);

        break;

      case '.json':
        _compileJson.default.compile(opath, config);

        break;

      default:
        let filepath = _path.default.join(opath.dir, opath.base);

        let content = _util.default.readFile(filepath) || '';

        let target = _util.default.getDistPath(opath, opath.ext, src, dist);

        _util.default.output('编译', filepath);

        _util.default.output('写入', target);

        _util.default.writeFile(target, content);

        _cache.default.saveBuildCache();

    }
  }

};
exports.default = _default;